using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using System.Linq;

namespace Mod
{
        public class Mod
        {
            public static void Main()
            {
                  ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] JF",
                        DescriptionOverride = "El Creador del Mod.",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/JF_View.png"),
                        AfterSpawn = (Instance) =>
                        {   
                            var skin = ModAPI.LoadTexture("sprites/Characters/JeremyFSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);

                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                	    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Marno Moderno",
                        DescriptionOverride = "Marno ya esta viejo...",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Marno_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/MarnoNEWSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		    person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                	    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Counter",
                        DescriptionOverride = "Un Sargento Estadounidense que Lucho en la Guerra de Afganistan y contra los Guerrilla.",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Counter_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/CounterSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                	    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Kary",
                        DescriptionOverride = "Chica Semigata de Provenencia Alemana, El Personaje Favorito del Creador.",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Kary_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/KarySkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                            var body = Instance.transform.GetChild(5);
                            var cObj1 = new GameObject("tail");
                            cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                            cObj1.transform.localPosition = new Vector3(0f, 0f);
                            cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                            cObj1.transform.localScale = new Vector3(1f, 1f);
                            var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                            cSpr1.sprite = ModAPI.LoadSprite("sprites/Characters/CatTail.png");
                            cSpr1.sortingLayerName = "Top";
                	    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] James",
                        DescriptionOverride = "Joven Soldado Norteamericano de Provenencia Pakistani, Pertenece al Escuadron <color=#3F6BB2>CitySky.",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/James_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/JamesSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                	    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Michael With Mask",
                        DescriptionOverride = "Joven Soldado Norteamericano de Provenencia Noruego, Pertenece al Escuadron <color=#3F6BB2>CitySky (Version Capuchada).",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Michael_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/MichaelMaskSkinNEW.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
                            
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Gatuno",
                        DescriptionOverride = "Mejor amigo y Mascota de Marno, fan de las Whiskas y un personaje demasiado viejo.",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Gatuno_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/GatunoSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                            var body = Instance.transform.GetChild(5);
                            var cObj1 = new GameObject("tail");
                            cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                            cObj1.transform.localPosition = new Vector3(0f, 0f);
                            cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                            cObj1.transform.localScale = new Vector3(1f, 1f);
                            var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                            cSpr1.sprite = ModAPI.LoadSprite("sprites/Characters/CatTail.png");
                            cSpr1.sortingLayerName = "Top";
                            
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Arain",
                        DescriptionOverride = "Joven Humanoide de Origen Canadiense y Japones, Hija de Marno y Marna (y Monika: Sucesos Antes de la Historia La Infeccion Oscura)",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Arain_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/ArainSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                            var body = Instance.transform.GetChild(5);
                            var cObj1 = new GameObject("tail");
                            cObj1.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                            cObj1.transform.localPosition = new Vector3(0f, 0f);
                            cObj1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                            cObj1.transform.localScale = new Vector3(1f, 1f);
                            var cSpr1 = cObj1.AddComponent<SpriteRenderer>();
                            cSpr1.sprite = ModAPI.LoadSprite("sprites/Characters/tailWolf.png");
                            cSpr1.sortingLayerName = "Top";
						    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Android"),
                        NameOverride = "[CITYSKY] Robot#000001",
                        DescriptionOverride = "Maquinas Elaboradas por Marno quienes Mantendrian a CitySky al 100%",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Robot0001_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/Robot0001.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/4.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/5.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
						    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Android"),
                        NameOverride = "[CITYSKY] Robot#000002",
                        DescriptionOverride = "Maquinas Elaboradas por Marno quienes Mantendrian a CitySky al 100%",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Robot0002_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/Robot0002.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/4.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/5.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);
						    
                        }
                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Soldado / Soldier",
                        DescriptionOverride = "El Ejercito de CitySky",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Soldier_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/SoldiersCitySky/SoldierSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                        }
                    }
                );ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Soldado Variante 2 / Soldier Variant 2",
                        DescriptionOverride = "El Ejercito de CitySky",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Soldier2_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/SoldiersCitySky/SoldierSkin2.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                        }
                    }
                );ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Soldado Variante 3 / Soldier Variant 3",
                        DescriptionOverride = "El Ejercito de CitySky",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Soldier3_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/SoldiersCitySky/SoldierSkin3.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                        }
                    }
                );ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Soldado Variante 4 / Soldier Variant 4",
                        DescriptionOverride = "El Ejercito de CitySky",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Soldier4_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/SoldiersCitySky/SoldierSkin4.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                        }
                    }
                );ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Danielle",
                        DescriptionOverride = "El Viejo miembro del Escuadron CitySky... El 1er Mexicano del Equipo",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Daniel_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/DanielleSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                        }
                    }
                );ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[CITYSKY] Crystal",
                        DescriptionOverride = "Miembro del Escuadron CitySky... la mecanica del equipo",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("sprites/Crystal_View.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var skin = ModAPI.LoadTexture("sprites/Characters/CrystalSkin.png");
	                        var flesh = ModAPI.LoadTexture("sprites/DEV Sprites/2.png"); //flesh
	                        var bone = ModAPI.LoadTexture("sprites/DEV Sprites/3.png"); //bone
                
                            var person = Instance.GetComponent<PersonBehaviour>();
                
            		        person.SetBodyTextures(skin, null, null, 6);
                
                            person.SetBruiseColor(86, 62, 130);
                            person.SetSecondBruiseColor(154, 0, 7);
                            person.SetThirdBruiseColor(207, 206, 120);
                            person.SetRottenColour(202, 199, 104);
                            person.SetBloodColour(108, 0, 4);

                        }
                    }
                );
            }
        }
}